// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

import { expect } from 'chai';

import { PageController } from './controller';
describe('TEST: findSurroundingPages', () => {
  const testMessages = {
    gesetz: {
      nameLink: 'Gesetz',
      regierungsinitiative: {
        nameLink: 'Regierungsinitiative',
        content: `<p>Nach Artikel 76 Absatz 1 GG können Gesetzentwürfe von der Bundesregierung, aus der „Mitte des Bundestages“ (dies sind mindestens 5 % der Mitglieder des Bundestages oder eine Fraktion) oder durch den Bundesrat in den Bundestag eingebracht werden. Den Kreis der Gesetzesinitianten regelt Artikel 76 Absatz 1 GG abschließend.</p>
                          <p>In der Staatspraxis überwiegen die Initiativen der Bundesregierung. Der hohe Anteil der Gesetzesinitiativen seitens der Bundesregierung ist dadurch begründet, dass die Bundesregierung die operative Gestaltung der Bundespolitik prägt und über die notwendigen fachlichen und personellen Ressourcen verfügt (Ministerialverwaltung, nachgeordnete Behörden).</p>`,
        phaseTitle1: {
          nameLink: 'Phase 1 <br>Erstellung eines Gesetzenwurfs durch die Bundesregierung',
        },
        vorueberlegungen11: {
          nameLink: '1.1 Vorüberlegungen',
          content: `<p>Die Federführung für die Erarbeitung eines Gesetzentwurfs liegt bei dem Ressort, dem das Sachgebiet nach der Geschäftsverteilung der Bundesregierung zugewiesen ist. Die Geschäftsverteilung erfolgt durch Organisationserlass des Bundeskanzlers.</p><p>Das federführende Ressort – und dort die zuständige Organisationseinheit, die mit der Durchführung des Gesetzgebungsverfahrens beauftragt ist – trägt die Gesamtverantwortung für die fachlichen Belange und die Einhaltung eines ordnungsgemäßen Verfahrens. Das Verfahren richtet sich nach der GGO.</p><p>Im Regelfall findet im Prozess der Erarbeitung des Regierungsentwurfs eine Rückkopplung zwischen der zuständigen Organisationseinheit und der Leitung des Ressorts statt. So kann beispielsweise eine Leitungsvorlage zur Notwendigkeit einer gesetzlichen Neuregelung und zu deren Zielen zu Eckpunkten des Vorhabens oder zu beabsichtigten Konsultationen notwendig sein. Eine Ausnahme von diesem Regelfall kann z.B. eine alternativlose Umsetzung von europarechtlichen Vorgaben in nationales Recht sein.</p><p>Eine Abstimmung des Gesetzentwurfs mit anderen Ministerien muss erfolgen, falls deren Belange betroffen sind.</p><h3><span style="letter-spacing: 0.16px;">Anlässe für ein Tätigwerden des federführenden Bundesministeriums</span></h3><p>Anlässe für ein Tätigwerden des federführenden Bundesministeriums können sich insbesondere ergeben durch:</p><p></p><ul><li>politische Weisung der Hausleitung</li><li>Beschluss der gesetzgebenden Körperschaften oder Zusagen der Bundesregierung ihnen gegenüber</li><li>Umsetzung des Regierungsprogramms oder einer Koalitionsvereinbarung</li><li>Gerichtsentscheidung</li><li>bevorstehendes Auslaufen vorhandener gesetzlicher Regelungen (befristete Gesetze)</li><li>Evaluierung des geltenden Rechts/retrospektive Gesetzesfolgenabschätzung (rGFA)</li><li>EU-Recht</li><li>Abschluss völkerrechtlicher Verträge (Vertragsgesetz und ggf. erforderliche Umsetzung in nationales Recht)</li><li>Aktivität der parlamentarischen Opposition</li><li>Vorschlag der Länder</li><li>Wunsch der Gesetzesanwender (z.B. Fachkreise und Verbände)</li><li>Vorschlag der Wissenschaft</li><li>Notwendigkeit aus eigener fachlicher Sicht</li><li>Petition</li><li>Bemerkungen/Empfehlungen/Forderungen etc. des Bundesrechnungshofes.</li></ul><p></p>`,
          linkedBibEntries: [
            'AH Experimentierklauseln',
            'EU-Handbuch',
            'GGO',
            'Leitfaden vV',
            'RiVeVo',
            'RvV',
            'Zusammenarbeit EU',
          ],
          linkedModules: ['zeit', 'rv'],
          pruefungregelungsnotwendigkeit111: {
            nameLink: '1.1.1 Prüfung: Regelungsnotwendigkeit',
            content: `<p>Zunächst wird in der Regel gefragt, ob ein Gesetz erforderlich ist (siehe <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 43 Absatz 1 Nummer 1 GGO</a>). Zur Feststellung der Erforderlichkeit sind verschiedene Aspekte zu beachten.</p><p></p><ol><li>Es muss geklärt werden, ob eine Regelung überhaupt notwendig ist. Es ist zu prüfen, ob für eine Neuregelung eine hinreichende Tatsachengrundlage gegeben ist und ob sich Ziele oder eine Problembewältigung auch anders - z.B. durch alternative Formen der Problembewältigung (z.B. Selbstregulierung) oder problemorientierte Auslegung/Anwendung der vorhandenen rechtlichen Regelungen - erreichen lassen. Eine Hilfestellung hierzu bietet die <a href="/#/evor">elektronische Vorbereitung von Regelungsentwürfen (eVoR)</a>. <br>Für die Klärung der Frage, ob ein festgestellter Regelungsbedarf statt durch hoheitliche Regulierung eher durch Selbstregulierung gedeckt werden sollte, finden Sie im „<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">Prüfkatalog zur Feststellung von Selbstregulierungsmöglichkeiten</a>" konkrete Hilfestellungen. Entscheidendes Kriterium für die Beantwortung der Fragen ist, ob sich die jeweils „schärfere" Form der Regulierung als notwendig i.S.d. <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 43 Absatz 1 Nummer 1 GGO</a> erweist.</li><li>Wenn die Notwendigkeit einer neuen Regelung bejaht wird, stellt sich die Frage, ob diese Regelung durch ein förmliches Gesetz erfolgen muss. Eine Regelung durch ein förmliches Gesetz ist nötig,<br>a. wenn zwingende verfassungsrechtliche Vorgaben vorliegen<br>b. wenn die änderungsbedürftige Rechtslage ihrerseits auf einem förmlichen Gesetz beruht. Insbesondere in Fällen, in denen eine Materie durch eine Kombination von gesetzlichen und untergesetzlichen Vorschriften ausgestaltet worden ist. muss daher sorgfältig geprüft werden, auf welcher Ebene der festgestellte Regelungsbedarf genau anzusiedeln ist.</li><li>Wenn die rechtliche Prüfung der Notwendigkeit einer neuen gesetzlichen Regelung negativ ausfällt, ist aus fachlicher und politischer Sicht zu fragen, ob eine Problemlösung durch den Erlass eines förmlichen Gesetzes dennoch geboten ist. Dies ist insbesondere dann anzunehmen, wenn eine Angelegenheit umstritten und deshalb die besondere Legitimation der entsprechenden Regelung angezeigt erscheint. Für den Erlass untergesetzlicher Normen sprechen dagegen deren Verfahrensökonomie und höhere Flexibilität bei etwaigem späterem Änderungsbedarf.<br></li><li>Soweit der festgestellte Regelungsbedarf nicht aus zwingenden rechtlichen Gründen durch ein förmliches Gesetz gedeckt werden muss, ist stets zu prüfen, ob eine gesellschaftliche Selbstregulierung einer staatlichen Regulierung vorzuziehen ist.</li></ol>`,
            linkedBibEntries: ['GGO'],
            linkedModules: ['zeit', 'rv', 'evor'],
          },
          zeitplanung112: {
            nameLink: '1.1.2 Zeitplanung',
            content: `<p>Die <a href="/#/zeit">Zeitplanung</a> ist ein wichtiger Arbeitsschritt zu Beginn eines Regelungsvorhabens. Es empfiehlt sich, bei der Zeitplanung vom geplanten Zeitpunkt des Inkrafttretens eines Gesetzes auszugehen und von diesem Zeitpunkt rückwirkend die Zeitpunkte der einzelnen Arbeitsschritte zu bestimmen. Der Zeitplan sollte stets aktualisiert werden. Eine Hilfestellung hierzu bietet die Anwendung&nbsp;<a href="/#/zeit">Elektronische Zeitplanung</a>.</p><h3>Kurzübersicht über die Schritte des Gesetzgebungsverfahrens und ihre Dauer</h3><p>Die angegebenen Zeiträume sind jeweils Schätz- bzw. Erfahrungswerte. Es empfiehlt sich, zeitliche Puffer einzuplanen.</p><p><b><a href="#/evir/gesetz/regierungsinitiative/vorueberlegungen11">Vorphase</a></b></p><p></p><ul><li>Konzeptionelle Überlegungen: Anlass des Tätigwerdens (z.B. Weisung der Hausleitung, Umsetzung des Koalitionsvertrags, ressortabgestimmtes Eckpunkte-Papier, EU-Richtlinie), Prüfung der politischen, inhaltlichen und zeitlichen Rahmenbedingungen, Prüfung von Regelungsalternativen und Gesetzesfolgen inkl. Erfüllungsaufwand</li><li>Ergänzung der Vorhabenplanung der BReg bis spätestens montags vier Wochen vor geplanter Kabinettbefassung (Unterrichtung des BK-Amtes gemäß <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 40 GGO</a>); ggf. PKP-Erfassung</li><li>Erstellung des Referentenentwurfs (Vorblatt, Gesetzentwurf, Begründung) unter Beachtung insbesondere der <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§§ 42, 43 und 44 GGO</a> und ggf. der einschlägigen Hausanordnungen</li></ul><p><b><a href="#/evir/gesetz/regierungsinitiative/hausabstimmung13/verfahrenaufarbeitsundstaatssekretaersebene131">Hausabstimmung</a></b> (Dauer: ca. zwei bis vier Wochen)</p><p></p><ul><li>Beachtung der ggf. einschlägigen Hausanordnungen</li><li>Beteiligung organisatorisch und fachlich betroffener Referate</li><li>ggf. Erörterung und Umsetzung der Änderungswünsche</li><li>frühzeitige Kontaktaufnahme mit dem Kabinett- und Parlamentreferat insbesondere mit Blick auf den Zeitplan für die Kabinettbefassung und das weitere Verfahren</li></ul><p></p><p><b><a href="#/evir/gesetz/regierungsinitiative/hausabstimmung13/entscheidunghausleitung132">Befassung Hausleitung</a></b> (mind. eine Woche vor Ressortabstimmung)</p><p></p><ul><li>Hausentwurf über festgelegten Dienstweg (z.B. Einbeziehung Kabinettreferat) an Hausleitung zur Billigung</li><li>nach Billigung durch die Hausleitung ggf. Vorabunterrichtung der Koalitionsfraktionen (Gelegenheit zur Stellungnahme)</li></ul><p></p><p><b><a href="#/evir/gesetz/regierungsinitiative/ressortabstimmungundweiterebeteiligungen14">Ressortabstimmung und weitere Beteiligungen</a></b> (Dauer: ca. vier Wochen (kürzere Frist möglich, insb. i.V.m. Ressortabstimmungen in Vorphase))</p><p></p><ul><li>rechtzeitige Beteiligung der betroffenen Ressorts, des Nationalen Normenkontrollrates, der Verfassungsressorts BMI und BMJV (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§§ 45, 46 GGO, Anlage 6 zu § 45 Absatz 1, § 74 Absatz 5 GG</a>O), der Beauftragten, ggf. unter Fristsetzung (für Schlussabstimmung grundsätzlich mindestens vier Wochen, bei umfangreichen und schwierigen Entwürfen auf Antrag acht Wochen, nur in begründeten Ausnahmefällen kürzer (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 50 GGO</a>))</li><li>Beachtung der Vorhabenplanung der Bundesregierung; ggf. Nachholen der PKP-Erfassung</li></ul><p></p><p>Ggf. während Ressortabstimmung, ggf. nach Billigung durch Ressorts:</p><p></p><ul><li>Beteiligung der Länder, der kommunalen Spitzenverbände, der Fachkreise (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 47 GGO</a>)</li><li>bei Länder- und Verbändebeteiligung zeitgleiche Kenntnisgabe des Entwurfs an die Geschäftsstellen der Fraktionen des Deutschen Bundestages und des Bundesrates (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 48 Absatz 2 GGO</a>), danach Veröffentlichung im Internet</li><li>ggf. Erörterung und Umsetzung der Änderungswünsche</li></ul><p><b><a href="#/evir/gesetz/regierungsinitiative/kabinettbeschluss16/kabinettvorlageanhausleitung162">Kabinettvorlage an Hausleitung</a></b> (spätestens freitags zehn Tage vor gepl. Kabinetteinbringung (Begründete Nachmeldung mit St- Vorlage bis freitags 12 Uhr vor Kabinett mgl.))</p><p>Beachtung der <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§§ 22, 23, 51 GGO</a> und ggf. der einschlägigen Hausanordnung</p><p>Vorlage folgender Dokumente auf Dienstweg (z.B. Kabinettreferat) an Hausleitung:</p><p></p><ul><li>Kabinettvorlage (Außenverteiler [Anzahl nach <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 23 Absatz 1 GGO</a> vom BK festgelegt] plus ressortinterner Verteiler) bestehend aus (ggf. Hausanordnung für einschlägiges Muster beachten):</li><li>Ministeranschreiben an ChefBK</li><li>Anlage 1: Beschlussvorschlag</li><li>Anlage 2: Sprechzettel für den Regierungssprecher</li><li>Anlage 3: Vorblatt, Gesetzentwurf, Begründung zum Gesetzentwurf</li><li>Anlage 4: Stellungnahme des Nationalen Normenkontrollrates</li><li>Zeitplan</li></ul><p><b><a href="#/evir/gesetz/regierungsinitiative/kabinettbeschluss16/kabinettbeschluss164">Kabinettbeschluss</a></b> (mittwochs oder in Ausnahmen Umlaufverfahren)</p><p><b><a href="#/evir/gesetz/regierungsinitiative/stellungnahmebundesrat17">Zuleitung an Bundesrat durch BK-Amt</a></b> (sechs Wo. vor nächster BR- Sitzung (Fristverkürzung möglich))</p><p></p><ul><li>Beachtung des Sitzungskalenders<br>Stellungnahme des Bundesrates innerhalb von sechs Wochen (Artikel 76 Absatz 2 Satz 2 GG); Fristverkürzung zur Stellungnahme durch begründeten Antrag der Bundesregierung gegenüber dem Ständigen Beirat des Bundesrates möglich</li><li>ggf. Entwurf der Gegenäußerung der BReg zur Stellungnahme des Bundesrates und Herbeiführung des Kabinettbeschlusses hierüber (beachte <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 53 GGO</a>).<br>nach Befassung im Bundesrat (Ausnahme: Eilbedürftigkeit)</li></ul><p></p><p><b><a href="#/evir/gesetz/regierungsinitiative/bundestag19">Zuleitung an Bundestag</a></b> (nach Befassung im Bundesrat (Ausnahme: Eilbedürftigkeit))</p><p></p><ul><li>Gesetzentwurf, Stellungnahme des Bundesrates, Gegenäußerung BReg. Bei Eilbedürftigkeit (Kabinettbeschluss hierüber erforderlich): Weiterleitung drei Wochen nach Zuleitung an den Bundesrat möglich. Die Stellungnahme des Bundesrates muss dann umgehend nachgereicht werden (Artikel 76 Absatz 2 Satz 4 GG).</li></ul><p></p><p><b><a href="#/evir/gesetz/regierungsinitiative/beratungbundestag21">Befassung Bundestag</a></b> (Dauer: in der Regel. mind. drei Wochen)</p><p>Beachtung des Sitzungskalenders</p><p></p><ul><li>Erste Lesung (Donnerstag oder Freitag), Überweisung an Ausschuss, Befassung im Ausschuss (Mittwoch), ggf. Anhörung</li><li>ggf. Entwurf von Formulierungsvorschlägen bei Änderungswünschen<br>Zweite und dritte Lesung (Do. oder Fr.), anschl. Weiterleitung an Bundesrat</li></ul><p><b><a href="#/evir/gesetz/regierungsinitiative/beratungbundesrat22">Zweite Befassung Bundesrat</a></b> (ca. zwei bis drei Wochen nach Zuleitung durch Bundestag)</p><p>Beachtung des Sitzungskalenders</p><p></p><ul><li>bei Einspruchsgesetz: BRat kann zustimmen oder innerhalb von drei Wochen Vermittlungsausschuss anrufen, danach innerhalb von zwei Wochen Einspruch einlegen, welchen der BT durch erneute Beschlussfassung zurückweisen kann</li><li>bei Zustimmungsgesetz: Beschlussfassung in angemessener Frist, Artikel 77 Absatz 2a GG; Zustimmung in der Regel in nächster BRat-Sitzung nach Zuleitung</li></ul><p></p><p><b><a href="#/evir/gesetz/regierungsinitiative/ausfertigungundverkuendung31/herstellungderurschrift312">Herstellung der Urschrift</a></b> (Dauer: ca. zwei Wochen)</p><p></p><ul><li>Beachtung der <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§§ 58, 59 GGO</a> und ggf. der einschlägigen Hausanweisungen</li><li>Veranlassung der Urschrift des Gesetzes bei der Schriftleitung des Bundesgesetzblattes (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 58 GGO</a>)</li><li>ggf. Bereinigung von Druckfehlern oder offensichtlichen Unrichtigkeiten im Berichtigungsverfahren (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 61 Absatz 2 GGO</a>)</li><li>Herbeiführung der Gegenzeichnung durch Mitglieder der BReg (<a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 58 Absatz 3 GGO</a>)</li></ul><p></p><p><b><a href="#/evir/gesetz/regierungsinitiative/ausfertigungundverkuendung31/gegenzeichnungderurschrift313">Gegenzeichnung durch BK</a> und <a href="#/evir/gesetz/regierungsinitiative/ausfertigungundverkuendung31/ausfertigungdurchdenbundespraesidenten315">Ausfertigung durch BPräs</a></b></p><p><b><a href="#/evir/gesetz/regierungsinitiative/ausfertigungundverkuendung31/verkuendung316">Verkündung des Gesetzes</a> (Artikel 82 Absatz 1 GG; <a href="/egesetzgebung-platform-backend/arbeitshilfen/download/34">§ 60 GGO</a>)</b></p><p><b>Inkrafttreten des Gesetzes (Artikel 82 Absatz 2 GG)</b> (14 Tage nach Verkündung, falls Inkrafttreten nicht im Gesetz selbst geregelt ist)</p><p></p><p></p><p></p><p></p>`,
            linkedBibEntries: [],
            linkedModules: ['zeit', 'rv'],
          },
          materialrecherche113: {
            nameLink: '1.1.3 Materialrecherche',
            content: ``,
            linkedBibEntries: [],
            linkedModules: [],
          },
          eckpunkteundprospektivefolgenabschaetzung114: {
            nameLink: '1.1.4 Eckpunkte und prospektive Folgenabschätzung',
            content: ``,
            linkedBibEntries: [],
            linkedModules: [],
          },
        },
      },
    },
  };
  const pageController = new PageController(testMessages);
  it('(gesetz) first level, first element in array, should return correct sourroundig pages', () => {
    const response = pageController.findSurroundingPages('gesetz', 'gesetz');
    expect(response.before).undefined;
    expect(response.after).to.eql('gesetz/regierungsinitiative');
  });
  it('(gesetz.regierungsinitiative) second level, first element in array, should return correct sourroundig pages', () => {
    const response = pageController.findSurroundingPages('gesetz.regierungsinitiative', 'gesetz.regierungsinitiative');
    expect(response.before).undefined;
    expect(response.after).to.eql('gesetz/regierungsinitiative/vorueberlegungen11');
  });
  it('(gesetz.regierungsinitiative.vorueberlegungen11.pruefungregelungsnotwendigkeit111) third level, first element in array, should return correct sourroundig pages', () => {
    const response = pageController.findSurroundingPages(
      'gesetz.regierungsinitiative.vorueberlegungen11.pruefungregelungsnotwendigkeit111',
      'gesetz.regierungsinitiative',
    );
    expect(response.before).to.eql('gesetz/regierungsinitiative/vorueberlegungen11');
    expect(response.after).to.eql('gesetz/regierungsinitiative/vorueberlegungen11/zeitplanung112');
  });
  it('(gesetz.regierungsinitiative.vorueberlegungen11.materialrecherche113) third level, last element in array, should return correct sourroundig pages', () => {
    const response = pageController.findSurroundingPages(
      'gesetz.regierungsinitiative.vorueberlegungen11.materialrecherche113',
      'gesetz.regierungsinitiative',
    );
    expect(response.before).to.eql('gesetz/regierungsinitiative/vorueberlegungen11/zeitplanung112');
    expect(response.after).to.eql(
      'gesetz/regierungsinitiative/vorueberlegungen11/eckpunkteundprospektivefolgenabschaetzung114',
    );
  });
});
